from zope.component import getMultiAdapter

from Products.CMFCore.utils import getToolByName
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from plone.app.layout.viewlets.common import ViewletBase


class CellMLSearchViewlet(ViewletBase):
    """\
    Search specifically for CellML
    """

    index = ViewPageTemplateFile('cellml_search_viewlet.pt')

    def update(self):
        super(CellMLSearchViewlet, self).update()

        context_state = getMultiAdapter((self.context, self.request),
                                        name=u'plone_context_state')

        props = getToolByName(self.context, 'portal_properties')
        livesearch = props.site_properties.getProperty('enable_livesearch', False)
        if livesearch:
            self.search_input_id = "liveSearchCellML"
        else:
            self.search_input_id = "SearchCellML"

        folder = context_state.folder()
        self.folder_path = '/'.join(folder.getPhysicalPath())
